/***************************************************************************
                          bcview.h  -  description
                             -------------------
    begin                : Sun Jun 17 19:19:58 CEST 2001
    copyright            : (C) 2001 by Michael Andreen
    email                : whale@linux.nu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BCVIEW_H
#define BCVIEW_H

// include files for QT
#include <qsplitter.h>

// application specific includes
#include "bsdoc.h"

class BattleSum;
class ScanView;
class InfoView;
class TickView;
class FleetViewBase;

//QT forward declarations
class QListView;
class QSplitter;
class QWidgetStack;
class QListViewItem;

/**
 * This class provides an incomplete base for your application view. 
 */

class BSView : public QSplitter
{
  Q_OBJECT
  public:
    BSView(QWidget *parent=0, BSDoc* doc=0);
    ~BSView();
		
		void addBattle(QString name);

  protected slots:
    void slotDocumentChanged();

  protected:
  	BattleSum	*m_BattleSum;
	QListView		*m_NumberView;
	QSplitter		*m_RightSplit;	
	QSplitter		*m_LeftSplit;
	ScanView		*m_ScanView;
	InfoView		*m_InfoView;
	TickView		*m_TickView;
	QWidgetStack	*m_FleetViews;
	FleetViewBase	*m_FleetView;
	BSDoc			*m_doc;
  
public slots: // Public slots
  /** No descriptions */
  void slotFleetSelection(QListViewItem *lvi);
};

#endif
